import React from "react";

export default class ListItem extends React.Component {
    render() {
        let isCompleted = this.props.item.completed;
        let isError = this.props.item.error;

        const Buttons = ({ completeButton = true, closeButton = true }) => {
            return (
                <>
                    {completeButton ? (
                        <span className="complete" onClick={this.complete.bind(this, this.props.item.id)}>
                            ✔
                        </span>
                    ) : null}

                    {closeButton ? (
                        <span className="close" onClick={this.delete.bind(this, this.props.item.id)}>
                            ✕
                        </span>
                    ) : null}
                </>
            );
        };

        return (
            <>
                <li className={"todo-item " + (isCompleted ? "complete " : "") + (isError ? "error " : "")}>
                    <span className="todo-item-number">{this.props.number}</span>
                    <span className="todo-item-text">{this.props.item.text}</span>
                    {isCompleted ? null : <Buttons completeButton={!isError} />}
                </li>
            </>
        );
    }

    delete(id) {
        this.props.delete(id);
    }

    complete(id) {
        this.props.complete(id);
    }
}
